/*********************************************************************
  ulib/graphics/lowlevel/yuv2rgb16.hh

  purpose:
    Transform YUV data into 16bit true color RGB raw data.
    Every bit organization in a 16bit field and endianess
    translation is supported.

  notes:

  to do:

  author(s):
   - Dirk Farin, farin@ti.uni-mannheim.de
     University Mannheim, Dept. Circuitry and Simulation
     B 6,26 EG, room 0.10 / D-68131 Mannheim / Germany

  modifications:
    08/Aug/1999 - Dirk Farin - code imported from DVDview and
                               slightly modified
 *********************************************************************/

#ifndef ULIB_GRAPHICS_LOWLEVEL_YUV2RGB16_HH
#define ULIB_GRAPHICS_LOWLEVEL_YUV2RGB16_HH

#include "ulib/graphics/lowlevel/img2raw.hh"

class i2r_16bit : public Image2Raw_TransformYUV
{
public:
  virtual ~i2r_16bit() { }

  void SetMask(uint16 redmask,uint16 greenmask,uint16 bluemask);
  void SetLittleEndian(bool flag) { littleendian=flag; }

  virtual void Transform(const Image_YUV<Pixel>&,uint8* mem);

  virtual const char* TransformationName() { return "scalar YUV to 16bit RGB"; }

private:
  uint16 rmask,gmask,bmask;
  int    rshift,gshift,bshift;
  bool   littleendian;
};

#endif
